<template>
    <div :class="[fullwidth ? 'fullwidthStyle' : 'localechanger']">
        <q-select
            v-model="lang"
            :options="localeOptions"
            borderless
            emit-value
            map-options
            options-dense
            v-bind:class="[fullwidth ? 'fullwidthStyle' : 'localechanger']">
            <template v-slot:selected-item="sel">
                <q-item v-bind="sel.itemProps">
                    <q-item-section>
                        <q-item-label :class="textcolstyle">
                            {{ sel.opt.label }}
                        </q-item-label> 
                    </q-item-section>
                    <q-item-section avatar>
                        <img style="max-height:30px;" v-bind:src="flags[sel.opt.value]" />
                    </q-item-section>
                </q-item>
            </template>
            <template v-slot:option="scope">
                <q-item v-bind="scope.itemProps" v-on="scope.itemEvents">
                    <q-item-section>
                        <q-item-label>{{ scope.opt.label }}</q-item-label> 
                    </q-item-section>
                    <q-item-section avatar>
                        <img style="max-height:30px;" v-bind:src="flags[scope.opt.value]" />
                    </q-item-section>
                </q-item>
            </template>
        </q-select>

      </div>
</template>
<script>

var path = require('path');

export default {
    props: {
        fullwidth: {
            type: Boolean,
            default: false
        },
        textcolstyle: {
            type: String,
            default: 'text-grey-9'
        }
    },
    data() {
        return {
            lang: this.$root.$i18n.locale,
            localeOptions: [ 
                {value : 'en', label: 'English'}, 
                {value : 'np', label: 'नेपाली'},
                {value : 'bn', label: 'বাংলা'}
            ]
        };
    },
    created() {
        let locale = this.$cookie.get('locale');
        if(locale && locale !== 'undefined') 
        {
            this.lang = locale;
            this.$root.$i18n.locale = locale;
        }
        else
        {
            console.log('using default lang: ' + process.env.VUE_APP_DEFAULT_LANG)
            this.lang = process.env.VUE_APP_DEFAULT_LANG;
            this.$root.$i18n.locale = process.env.VUE_APP_DEFAULT_LANG;
        }
    },
    watch: {
        lang(newVal)
        {
            this.$root.$i18n.locale = newVal;
            this.$cookie.set('locale', newVal, { expires: '1Y' });
        }
    },
    computed: {
      // load all flags in folder into context
      // returns a dictionary with the countrycode as a key and the img as a value 
      flags () {
        const flagPaths = require.context('./../assets/flags', false, /\.png$/)

        let dict = {};

        flagPaths.keys().forEach(fl => {
            dict[path.basename(fl, '.png')] = flagPaths(fl);
        });

        return dict;
      }
    }
};
</script>
<style scoped>

    .fullwidthStyle {
        width: 100%;
        padding-left: 5px;
        padding-right: 5px;
        margin-left: auto;
        margin-right: auto;
    }

    .localechanger {
        width: 200px;
        padding: 5px;
        margin-left: auto;
        margin-right: auto;
        text-align: center;
    }

    .localechanger select {
        text-align: center;
        font-size: medium;
        text-align: center;
    }
</style>